﻿// Illustratorのバージョン番号とバージョン名をマッピング
var verList = {
    "11.0":"CS",
    "12.0":"CS2",
    "13.0":"CS3",
    "14.0":"CS4",
    "15.0":"CS5",
    "16.0":"CS6",
    "17.0":"CC legacy",
    "28.0":"CC 2024",
} 

var format = /%Creator:\sAdobe\sIllustrator\(R\)\s(\d+\.\d+)/;  // ファイルからバージョン情報を抽出する正規表現

var folder = Folder.selectDialog("AIファイルが含まれるフォルダを選択してください");// フォルダを選択

if (folder) {
    
    var files = folder.getFiles("*.ai");// 指定されたフォルダ内のすべての.aiファイルを取得します
    var results = [];// 結果を格納する配列
    
    for (var i = 0; i < files.length; i++) {
        var aiFile = new File(files[i]);
        var fileName =  File.decode(files[i].name);
        if (aiFile.open('r')){//ドキュメントの読み込み
            while (!aiFile.eof){//一番最後まで繰り返す
                if(aiFile.readln().match (format)) { //読み込んだファイルテキストから一致する「re」読みだす。
                    try {
                        //alert ('形式バージョン: '+ verList[RegExp.$1]);//呼び出した、一致するVersionを表示する
                        results.push (fileName + '_' + verList[RegExp.$1]);// + String.fromCharCode(13)
                    }
                    catch(err){
                        alert ('形式バージョン: unknown');
                    }
                    break;
                }
            }
         aiFile.close();
        }
    }
//alert (results.join('\n'));
var outputFile = new File(Folder.desktop + "/IllustratorVersions.txt");
    if (outputFile.open('w')) {
        outputFile.write(results.join('\n'));
        outputFile.close();
        alert("結果をデスクトップの IllustratorVersions.txt ファイルに書き出しました。");
    } else {
        alert("ファイルを開けませんでした。");
    }
}

/*
%Creator:：これは、ドキュメントのメタデータ内に存在する特定のキーワードです。このキーワードの後に続く情報を抽出します。
\s：これは空白文字（スペース、タブ、改行など）を表します。
Adobe\sIllustrator\(R\)：これは、ドキュメントがAdobe Illustratorによって作成されたことを示す文字列です。\(R\)は登録商標記号®を表します。
\d+\.\d+：これは、1つ以上の数字（\d+）、ピリオド（\.）、およびその後に1つ以上の数字（\d+）が続くパターンを表します。これはバージョン番号（例えば「24.0」）を表します。
したがって、この正規表現は「%Creator: Adobe Illustrator®」に続くバージョン番号を抽出します。
*/